<?php

/*
    This will test the input validation from the "Test this check/command/service" 
*/
class CmdValidationTest extends PHPUnit_Framework_TestCase
{
    function setUp()
    {
        evil_global_setup();
        set_user('host_7', array('op5_admins'));
        global $HOME, $IMPORTING;
        $cfgs = array($HOME.'mangleconfig.cfg', $HOME.'testconfig.cfg');
        require_once('include/import.inc.php');
        $this->service = new cmd_test_nacoma_Model();
        $this->dangerous_characters = str_split(";&`~^\"|'<>");
        array_push($this->dangerous_characters, "$(");
        $this->test_command = "_USER1_/check_by_snmp_extend --indexname check_mon_cpu --hostname localhost --protocol 3 -a SHA -A 59a54a9b9995506865879d07f5d78344 -x AES -X 486dee420cc3db7eb3b73a3e38fe5f37 -U op5-snmp-user";
    }

    function tearDown()
    {
        evil_global_teardown();
    }
    
    function testIfCommandHasDangerousCharacters(){
        $invalid = 0;
        foreach ($this->dangerous_characters as $value) {
            if($this->service->contains_dangerous_characters("$this->test_command .= $value") === TRUE){
                $invalid++;
            };
        }
        $this->assertEquals($invalid, count($this->dangerous_characters));
    }
    function testIfValidationValid(){
        $this->assertFalse($this->service->contains_dangerous_characters($this->test_command));
    }
}
