<?php
require_once('devtools/phptap.php');
if (!empty($main_tap)) {
	$tap = $main_tap->sub_init('Helptexts');
} else {
	$tap = new phptap('Helptext');
}

function test_helptexts($tap)
{
	$help = json_decode(file_get_contents(dirname(__FILE__).'/../../js/helptexts.json'), true);
	$tap->ok(null !== $help, "Failed to parse helptexts.json as JSON");

	$all_vars = array();
	$h = opendir(__DIR__ . '/../../classes');
	while ($file = readdir($h)) {
		$class = substr($file, 0, -4);
		if (class_exists($class) && is_subclass_of($class, 'object_nacoma_Model')) {
			$sub = $tap->sub_init('Helptexts for '.$class);
			$obj = new $class();
			$props = $obj->get_properties();
			if (is_array($props['var_index']))
				foreach ($props['var_index'] as $var => $_) {
					$sub->ok(isset($help[$var]), "{$obj->type} should have helptext for property '$var'");
					if (isset($help[$var]) && is_array($help[$var])) {
						$sub->ok(isset($help[$var][$obj->type]), "As $var has object-specific helptexts, it should have one for {$obj->type}");
					}
				}
			$sub->done();
		}
	}
	closedir($h);
	$tap->done();
}
test_helptexts($tap);

$tap->done(empty($main_tap));
